package ISet;

import java.io.*;
import java.util.*;

/* TESTO
   Un insieme finito e' un tipo di dato strutturato, 'a set, della forma 
   {x1,...,xn}, per n>=0, a componenti xi omogenei e contenente al piu'
   un'occorrenza di uno stesso valore, xi=xj iff i=j. 
   I valori 'a set sono valori Immutable, sui quali possiamo operare me-
   diante le sole seguenti operazioni:
        empty: unit -> 'a set
        sing: 'a -> 'a set
        isin: 'a -> 'a set -> bool
        union: 'a set -> 'a set -> 'a set
        inter: 'a set -> 'a set -> 'a set
        diff: 'a set -> 'a set -> 'a set
        card: 'a set -> int
        toString: 'a set -> string
   Si dia una implementazione in Java di Iset per tipi di dato int set
   tale che:
   (1) Si utlizzi una classe di nome Iset per l'implementazione
   (2) Lo stato della rappresentazione utilizzi Vector<Int>
   (3) Non si sovraccarichi la rappresentazione con duplicati.
  */

/*
DOBBIAMO:
    (1) Completare (senza apportare modifiche) il codice fornito sotto;
    (2) Compilare in un eseguibile;
    (3) Eseguire verificando di ottenere il risultato indicato;
 */


public class Iset{
    Vector<Integer> rep;
    static Iset empty(){
        return new Iset();
    }
    static Iset sing(int x){
        return new Iset(x);
    }

    private Iset(){
        rep = new Vector<Integer>();
    }
    private Iset(int x){
        ...
    }
    public boolean isin(int x){
        return rep.contains(x);
    }
    public Iset union(Iset y){
        ...
    }
    public Iset diff(Iset y){
        ...
    }
    public Iset inter(Iset y){
        ...
    }
    public String toString(){
        String temp = rep.toString();
        temp = temp.substring(1,temp.length()-1);
        return "{" + temp + "}";
    }
    public static void main(String[] args){
        Iset s1 = Iset.sing(5);
        Iset s2 = Iset.sing(1);
        Iset s3 = s1.union(s2);
        System.out.println(s3.toString());
        Iset s4 = s3.union(s3);
        System.out.println(s4.toString());
        s4 = s4.diff(s4);
        System.out.println(s4.toString());
        s4 = s1.union(s2);
        Iset s5 = s4.inter(s1);
        System.out.println(s5.toString());
    }
}
/*
host-131-114-219-172:LabJava4-4-18 marcob$ javac iset.java -d .
host-131-114-219-172:LabJava4-4-18 marcob$ java ISet/Iset
{5, 1}
{5, 1}
{}
{5}
host-131-114-219-172:LabJava4-4-18 marcob$
*/




